#include <iostream>
#include <string>

using namespace std;

int main()
{
    int o,a,b,ab,potrebnoO=0,potrebnoA=0,potrebnoB=0,n,broj;
    bool mogucnost = true;
    cin >> n;
    int  potrebneKolicine[n];
    string krvneGrupe[n];
    cin >> o >> a >> b >> ab;
    for(int x=0; x<n; ++x)
    {
        cin >> krvneGrupe[x] >> broj;
        if(krvneGrupe[x] == "O")
            potrebnoO += broj;
        else if(krvneGrupe[x] == "A")
            potrebnoA += broj;
        else if(krvneGrupe[x] == "B")
            potrebnoB += broj;
        potrebneKolicine[x] = broj;
    }
    if(potrebnoO>o)
        mogucnost = false;
    if(potrebnoA>a){
        if(potrebnoA-a>o-potrebnoO)
            mogucnost = false;}
    if(potrebnoB>b){
        if(potrebnoB-b>o-potrebnoO-(potrebnoA-a))
            mogucnost = false;}
    if(mogucnost == true)
    {
        cout << "moguce" << endl;
        for(int x=0; x<n; ++x)
        {
            if(krvneGrupe[x] == "O")
            {
                o-= potrebneKolicine[x];
                cout << potrebneKolicine[x] << " " << 0 << " " << 0 << " " << 0 << endl;
            }
            else if(krvneGrupe[x] == "A")
            {
                if(a>=potrebneKolicine[x])
                {
                    a-= potrebneKolicine[x];
                    cout << 0 << " " << potrebneKolicine[x] << " " << 0 << " " << 0 << endl;
                }
                else if(potrebneKolicine[x] > a && a!=0)
                {
                    broj = a;
                    a-= broj;
                    o-= potrebneKolicine[x]-broj;
                    cout << potrebneKolicine[x]-broj << " " << broj << " " << 0 << " " << 0 << endl;
                }
                else if(potrebneKolicine[x] > a && a==0)
                {
                    o-= potrebneKolicine[x];
                    cout << potrebneKolicine[x] << " " << 0 << " " << 0 << " " << 0 << endl;
                }
            }
            else if(krvneGrupe[x] == "B")
            {
                if(b>=potrebneKolicine[x])
                {
                    b-= potrebneKolicine[x];
                    cout << 0 << " " << 0 << " " << potrebneKolicine[x] << " " << 0 << endl;
                }
                else if(potrebneKolicine[x] > b && b!=0)
                {
                    broj = b;
                    b-= broj;
                    o-= potrebneKolicine[x]-broj;
                    cout << potrebneKolicine[x]-broj << " " << 0 << " " << broj << " " << 0 << endl;
                }
                else if(potrebneKolicine[x] > b && b==0)
                {
                    o-= potrebneKolicine[x];
                    cout << potrebneKolicine[x] << " " << 0 << " " << 0 << " " << 0 << endl;
                }
            }
        }
    }
    else
        cout << "nemoguce" << endl;
}